# ../addons/eventscripts/eventscripts_extensions/modules/xcallblock/xcallblock.py


""" IMPORTS """
import es
import cmdlib

import psyco
psyco.full()


""" GLOBALS """
eventscripts_extensions = es.import_addon('eventscripts_extensions')


""" INITIALIZATION """
def load():
    cmdlib.registerServerCommand('xcallblock', ServerCommandCallBack, 'Syntax: xcallblock <script/block> [parameter-1] [parameter-2] [...]')
    
def unload():
    cmdlib.unregisterServerCommand('xcallblock')
    
    
""" UTILITIES """
def getBlockList():
    returnvalue = es.addons.Blocks.copy()
    for x in returnvalue:
        if not x.islower():
            returnvalue[x.lower()] = returnvalue[x]
            del returnvalue[x]
    return returnvalue
    
    
""" CALLBACKS """
def ServerCommandCallBack(arguments):
    if len(arguments) >= 1:
        block = arguments[0].lower()
        if es.exists('block', block):
            es.doblock(block)
        else:
            blocks = getBlockList()
            if blocks.has_key(block):
                try:
                    blocks[block](*arguments[1:])
                except:
                    eventscripts_extensions.echo('An error occurred when calling block "%s".' % arguments[0])
            else:
                eventscripts_extensions.echo('Unable to call block "%s".' % arguments[0])
    else:
        eventscripts_extensions.echo('Syntax: xcallblock <script/block> [parameter-1] [parameter-2] [...]')