# ../addons/eventscripts/eventscripts_extensions/modules/xgetviewplayer/xgetviewplayer.py


""" IMPORTS """
import es
import cmdlib

import psyco
psyco.full()


""" GLOBALS """
eventscripts_extensions = es.import_addon('eventscripts_extensions')


""" INITIALIZATION """
def load():
    cmdlib.registerServerCommand('xgetviewplayer', ServerCommandCallBack, 'Syntax: xgetviewplayer <variable> <userid>')
    
def unload():
    cmdlib.unregisterServerCommand('xgetviewplayer')
    
    
""" UTILITIES """
def setViewPlayer(variable, index):
    variable = es.ServerVar(variable, '-1')
    variable.set('-1')
    for userid, player in es.createplayerlist().items():
        if str(player['index']) == index:
            variable.set(str(userid))
            break
            
            
""" CALLBACKS """
def ServerCommandCallBack(arguments):
    if len(arguments) == 2:
        userid = str(es.getuserid(arguments[1]))
        if es.exists('userid', userid):
            es.server.insertcmd('xgetviewprop temp %s;' % userid +
                'es xcallblock eventscripts_extensions/modules/xgetviewplayer/setViewPlayer %s server_var(temp)' % arguments[0])
        else:
            eventscripts_extensions.echo('Unable to find player matching with "%s".' % arguments[1])
    else:
        eventscripts_extensions.echo('Syntax: xgetviewplayer <variable> <userid>')